#property copyright "Copyright(C) 2021, Papua"
#property strict
#define INDIVAL_CNT 3
extern int MaxBuyPosition = 3;
extern int MaxSellPosition = 3;
extern double Lots = 0.1;
extern int Slippage = 4;
extern double If_Num_0 = 30.000000;
extern double If_Num_1 = 70.000000;
extern double BuyOrder_Limit_0 = 10.000000;
extern double BuyOrder_Stop_0 = -90.000000;
extern double SellOrder_Limit_0 = 10.000000;
extern double SellOrder_Stop_0 = -90.000000;

int iIfchk[1500];
int Magic = 45218;
double dOrderSet[256][14];
int iOrderSetCnt;
string sOrderSetCom[256];
double dPoint;
int iCandlCheck[2][2] = {0,1,0,1};
datetime tCandlCheckTime[2];

int OnInit(){
   ArrayInitialize(dOrderSet,0);
   return(0);
}

void OnTick(){
   int i;
   int iTicket = 0;
   int iErrChk = 0;
   int iBuyCnt = 0;
   int iSellCnt = 0;
   int iBuyLimitCnt = 0;
   int iSellLimitCnt = 0;
   int iBuySetCnt = 0;
   int iSellSetCnt = 0;
   double dIndiVal[INDIVAL_CNT];
   ArrayInitialize(dIndiVal,0);

   dPoint = Point;
   if( Digits==3 || Digits==5 ) dPoint = Point * 10;

   if( OrdersTotal() > 0){
      for( i=0; i<OrdersTotal(); i++ ){
         if( OrderSelect(i, SELECT_BY_POS) == true && OrderMagicNumber() == Magic && OrderSymbol() == Symbol() ){
            if( OrderType() == OP_BUY ){
               iBuyCnt++;
            }else if( OrderType() == OP_SELL ){
               iSellCnt++;
            }else if( OrderType() == OP_BUYLIMIT || OrderType() == OP_BUYSTOP ){
               iBuyLimitCnt++;
            }else if( OrderType() == OP_SELLLIMIT || OrderType() == OP_SELLSTOP ){
               iSellLimitCnt++;
            }
         }
      }
   }

   dIndiVal[0] = iCustom(NULL,0,"RSI",14,0,3);
   dIndiVal[1] = iCustom(NULL,0,"RSI",14,0,2);
   dIndiVal[2] = iCustom(NULL,0,"RSI",14,0,1);


   ObjectCreate("indival0",OBJ_LABEL,0,0,0);
   ObjectSetText("indival0","RSI  Val_1  Shift_3       "+DoubleToStr(dIndiVal[0],Digits), 10, "Arial",  White);
   ObjectSet("indival0", OBJPROP_CORNER, 0);
   ObjectSet("indival0", OBJPROP_XDISTANCE, 30);
   ObjectSet("indival0", OBJPROP_YDISTANCE, 20);
   ObjectCreate("indival1",OBJ_LABEL,0,0,0);
   ObjectSetText("indival1","RSI  Val_1  Shift_2       "+DoubleToStr(dIndiVal[1],Digits), 10, "Arial",  White);
   ObjectSet("indival1", OBJPROP_CORNER, 0);
   ObjectSet("indival1", OBJPROP_XDISTANCE, 30);
   ObjectSet("indival1", OBJPROP_YDISTANCE, 37);
   ObjectCreate("indival2",OBJ_LABEL,0,0,0);
   ObjectSetText("indival2","RSI  Val_1  Shift_1       "+DoubleToStr(dIndiVal[2],Digits), 10, "Arial",  White);
   ObjectSet("indival2", OBJPROP_CORNER, 0);
   ObjectSet("indival2", OBJPROP_XDISTANCE, 30);
   ObjectSet("indival2", OBJPROP_YDISTANCE, 54);

   for( i=0; i<2; i++ ){
      if( iCandlCheck[i][0] >= 1 ){
         if( tCandlCheckTime[i] != iTime(NULL,0,1) ){
            iCandlCheck[i][0]--;
            tCandlCheckTime[i] = iTime(NULL,0,1);
         }
      }
   }

   if( iOrderSetCnt == 0 ){
      if( dIndiVal[0] <= dIndiVal[1] ){
         if( dIndiVal[1] > dIndiVal[2] ){
            iIfchk[0]++;
            if( dIndiVal[1] < If_Num_0 ){
               iIfchk[1]++;
               if( iBuyCnt + iBuyLimitCnt + iBuySetCnt < MaxBuyPosition ){
                  if( iCandlCheck[0][0] == 0 ){
                     /////////////////////////////////////////////////////////////;
                     dOrderSet[iOrderSetCnt][0] = 1;  //1:@2:@3Fwl@4Fwl
                     dOrderSet[iOrderSetCnt][1] = 1;  //Lot~X
                     dOrderSet[iOrderSetCnt][2] = MarketInfo(Symbol(),MODE_ASK);  //I[_[[g
                     dOrderSet[iOrderSetCnt][3] = 1;  //Limitݒ 0FȂ 1:Pipsݒ 2:[gݒ
                     dOrderSet[iOrderSetCnt][4] = 1;  //Stopݒ 0FȂ 1:Pipsݒ 2:[gݒ
                     dOrderSet[iOrderSetCnt][5] = BuyOrder_Limit_0;  //Limit̃[g(vpips)
                     dOrderSet[iOrderSetCnt][6] = BuyOrder_Stop_0;  //Stop̃[g(vpips)
                     dOrderSet[iOrderSetCnt][7] = 1;  //0:[\NȂ 1ȏ:[\N
                     dOrderSet[iOrderSetCnt][8] = 0;  //--
                     dOrderSet[iOrderSetCnt][9] = 0;  //--
                     dOrderSet[iOrderSetCnt][10] = 0;  //L
                     dOrderSet[iOrderSetCnt][11] = 0;  //0:oߎԒȂ 1ȏ:oߎԒ
                     dOrderSet[iOrderSetCnt][13] = 0;  //--
                     sOrderSetCom[iOrderSetCnt] = "";  //|WVRg
                     iOrderSetCnt++;
                     iBuySetCnt++;
                     ////////////////////////////////////////////////////////////////////
                  }
               }
            }
         }
      }
      if( dIndiVal[0] >= dIndiVal[1] ){
         if( dIndiVal[1] < dIndiVal[2] ){
            iIfchk[2]++;
            if( dIndiVal[1] > If_Num_1 ){
               iIfchk[3]++;
               if( iSellCnt + iSellLimitCnt + iSellSetCnt < MaxSellPosition ){
                  if( iCandlCheck[1][0] == 0 ){
                     //蒍///////////////////////////////////////////////////////////;
                     dOrderSet[iOrderSetCnt][0] = 2;  //1:@2:@3Fwl@4Fwl
                     dOrderSet[iOrderSetCnt][1] = 1;  //Lot~X
                     dOrderSet[iOrderSetCnt][2] = MarketInfo(Symbol(),MODE_BID);  //I[_[[g
                     dOrderSet[iOrderSetCnt][3] = 1;  //Limitݒ 0FȂ 1:Pipsݒ 2:[gݒ
                     dOrderSet[iOrderSetCnt][4] = 1;  //Stopݒ 0FȂ 1:Pipsݒ 2:[gݒ
                     dOrderSet[iOrderSetCnt][5] = SellOrder_Limit_0;  //Limit̃[g(vpips)
                     dOrderSet[iOrderSetCnt][6] = SellOrder_Stop_0;  //Stop̃[g(vpips)
                     dOrderSet[iOrderSetCnt][7] = 2;  //0:[\NȂ 1ȏ:[\N
                     dOrderSet[iOrderSetCnt][8] = 0;  //--
                     dOrderSet[iOrderSetCnt][9] = 0;  //--
                     dOrderSet[iOrderSetCnt][10] = 0;  //L
                     dOrderSet[iOrderSetCnt][11] = 0;  //0:oߎԒȂ 1ȏ:oߎԒ
                     dOrderSet[iOrderSetCnt][13] = 0;  //--
                     sOrderSetCom[iOrderSetCnt] = "";  //|WVRg
                     iOrderSetCnt++;
                     iSellSetCnt++;
                     ////////////////////////////////////////////////////////////////////
                  }
               }
            }
         }
      }
   }

   if( iOrderSetCnt > 0 ) OrderFunction();
   return;
}

void OrderFunction(){
   int i;
   int iTicket;
   int iCCheck;
   int iOrderType     = 0;
   double dOrderRate  = 0;
   double dOrderLimit = 0;
   double dOrderStop  = 0;
   double dSetPrice   = 0;
   color cOrderColor  = 0;
   datetime tOrderExp = 0;
   static int iCheckCnt;

   RefreshRates();

   if( dOrderSet[iCheckCnt][9] >= 10 ){
      dOrderSet[iCheckCnt][0] = 0;
      dOrderSet[iCheckCnt][9] = 0;
      dOrderSet[iCheckCnt][13] = 0;
      sOrderSetCom[iCheckCnt] = "";
      iCheckCnt++;
   }

   if( dOrderSet[iCheckCnt][0] >= 1 && dOrderSet[iCheckCnt][0] <= 4 ){
      i = (int)dOrderSet[iCheckCnt][0];
      switch( i ){
         case 1:
            cOrderColor = Red;
            iOrderType = 0;
            dOrderRate = MarketInfo(Symbol(),MODE_ASK);
            dOrderLimit = 0;
            dOrderStop = 0;
            if( dOrderSet[iCheckCnt][3] == 1 ) dOrderLimit = dOrderSet[iCheckCnt][2]+(dOrderSet[iCheckCnt][5]*dPoint);
            if( dOrderSet[iCheckCnt][4] == 1 ) dOrderStop = dOrderSet[iCheckCnt][2]+(dOrderSet[iCheckCnt][6]*dPoint);
            if( dOrderSet[iCheckCnt][3] == 2 ) dOrderLimit = dOrderSet[iCheckCnt][5];
            if( dOrderSet[iCheckCnt][4] == 2 ) dOrderStop = dOrderSet[iCheckCnt][6];
            tOrderExp = 0;
            break;
         case 2:
            cOrderColor = Blue;
            iOrderType = 1;
            dOrderRate = MarketInfo(Symbol(),MODE_BID);
            dOrderLimit = 0;
            dOrderStop = 0;
            if( dOrderSet[iCheckCnt][3] == 1 ) dOrderLimit = dOrderSet[iCheckCnt][2]-(dOrderSet[iCheckCnt][5]*dPoint);
            if( dOrderSet[iCheckCnt][4] == 1 ) dOrderStop = dOrderSet[iCheckCnt][2]-(dOrderSet[iCheckCnt][6]*dPoint);
            if( dOrderSet[iCheckCnt][3] == 2 ) dOrderLimit = dOrderSet[iCheckCnt][5];
            if( dOrderSet[iCheckCnt][4] == 2 ) dOrderStop = dOrderSet[iCheckCnt][6];
            tOrderExp = 0;
            break;
         case 3:
            cOrderColor = Red;
            iOrderType = 2;
            if( MarketInfo(Symbol(),MODE_ASK) < dOrderSet[iCheckCnt][2] ) iOrderType = 4;
            dOrderRate = dOrderSet[iCheckCnt][2];
            dOrderLimit = 0;
            dOrderStop = 0;
            if( dOrderSet[iCheckCnt][3] == 1 ) dOrderLimit = dOrderSet[iCheckCnt][2]+(dOrderSet[iCheckCnt][5]*dPoint);
            if( dOrderSet[iCheckCnt][4] == 1 ) dOrderStop = dOrderSet[iCheckCnt][2]+(dOrderSet[iCheckCnt][6]*dPoint);
            if( dOrderSet[iCheckCnt][3] == 2 ) dOrderLimit = dOrderSet[iCheckCnt][5];
            if( dOrderSet[iCheckCnt][4] == 2 ) dOrderStop = dOrderSet[iCheckCnt][6];
            tOrderExp = 0;
            if(dOrderSet[iCheckCnt][10] > 0) tOrderExp = (datetime)(TimeCurrent()+dOrderSet[iCheckCnt][10]);
            break;
         case 4:
            cOrderColor = Blue;
            iOrderType = 3;
            if( MarketInfo(Symbol(),MODE_ASK) > dOrderSet[iCheckCnt][2] ) iOrderType = 5;
            dOrderRate = dOrderSet[iCheckCnt][2];
            dOrderLimit = 0;
            dOrderStop = 0;
            if( dOrderSet[iCheckCnt][3] == 1 ) dOrderLimit = dOrderSet[iCheckCnt][2]-(dOrderSet[iCheckCnt][5]*dPoint);
            if( dOrderSet[iCheckCnt][4] == 1 ) dOrderStop = dOrderSet[iCheckCnt][2]-(dOrderSet[iCheckCnt][6]*dPoint);
            if( dOrderSet[iCheckCnt][3] == 2 ) dOrderLimit = dOrderSet[iCheckCnt][5];
            if( dOrderSet[iCheckCnt][4] == 2 ) dOrderStop = dOrderSet[iCheckCnt][6];
            tOrderExp = 0;
            if(dOrderSet[iCheckCnt][10] > 0) tOrderExp = (datetime)(TimeCurrent()+dOrderSet[iCheckCnt][10]);
            break;
      }
      iTicket = OrderSend( Symbol(),iOrderType,Lots*dOrderSet[iCheckCnt][1],NormalizeDouble(dOrderRate, Digits),Slippage,NormalizeDouble(dOrderStop, Digits),NormalizeDouble(dOrderLimit, Digits),sOrderSetCom[iCheckCnt],Magic+(int)dOrderSet[iCheckCnt][12],tOrderExp,cOrderColor );
      if( iTicket < 0 ){
         Print( "Error OrderSend :",GetLastError() );
         dOrderSet[iCheckCnt][9]++;
      }else{
         if( dOrderSet[iCheckCnt][7] > 0 ){
            iCCheck = (int)dOrderSet[iCheckCnt][7] - 1;
            iCandlCheck[iCCheck][0] = iCandlCheck[iCCheck][1];
            tCandlCheckTime[iCCheck] = iTime(NULL,0,1);
         }
         sOrderSetCom[iCheckCnt] = "";
         iCheckCnt++;
      }
   }

   if( dOrderSet[iCheckCnt][0] == 5 || dOrderSet[iCheckCnt][0] == 6 ){
      if( OrderSelect((int)dOrderSet[iCheckCnt][8], SELECT_BY_TICKET) ){
         i = (int)dOrderSet[iCheckCnt][0];
         if( dOrderSet[iCheckCnt][2] != 0 ){
            dSetPrice = dOrderSet[iCheckCnt][2];
         }else{
            dSetPrice = OrderOpenPrice();
         }
         switch( i ){
            case 5:
               cOrderColor = Red;
               dOrderLimit = 0;
               dOrderStop = 0;
               if( dOrderSet[iCheckCnt][3] == 1 ) dOrderLimit = dSetPrice+(dPoint*dOrderSet[iCheckCnt][5]);
               if( dOrderSet[iCheckCnt][4] == 1 ) dOrderStop = dSetPrice+(dPoint*dOrderSet[iCheckCnt][6]);
               if( dOrderSet[iCheckCnt][3] == 2 ) dOrderLimit = dOrderSet[iCheckCnt][5];
               if( dOrderSet[iCheckCnt][4] == 2 ) dOrderStop = dOrderSet[iCheckCnt][6];
               break;
            case 6:
               cOrderColor = Blue;
               dOrderLimit = 0;
               dOrderStop = 0;
               if( dOrderSet[iCheckCnt][3] == 1 ) dOrderLimit = dSetPrice-(dPoint*dOrderSet[iCheckCnt][5]);
               if( dOrderSet[iCheckCnt][4] == 1 ) dOrderStop = dSetPrice-(dPoint*dOrderSet[iCheckCnt][6]);
               if( dOrderSet[iCheckCnt][3] == 2 ) dOrderLimit = dOrderSet[iCheckCnt][5];
               if( dOrderSet[iCheckCnt][4] == 2 ) dOrderStop = dOrderSet[iCheckCnt][6];
               break;
         }
         if( OrderTakeProfit() != dOrderLimit || OrderTakeProfit() != dOrderStop ){
            if( OrderModify( (int)dOrderSet[iCheckCnt][8],OrderOpenPrice(),NormalizeDouble(dOrderStop, Digits),NormalizeDouble(dOrderLimit, Digits),0,cOrderColor ) ){
               sOrderSetCom[iCheckCnt] = "";
               iCheckCnt++;
            }else{
               dOrderSet[iCheckCnt][9]++;
            }
         }else{
            sOrderSetCom[iCheckCnt] = "";
            iCheckCnt++;
         }
      }else{
         sOrderSetCom[iCheckCnt] = "";
         iCheckCnt++;
      }
   }

   if( iCheckCnt >= iOrderSetCnt ){
      iOrderSetCnt = 0;
      iCheckCnt = 0;
      ArrayInitialize(dOrderSet,0);
   }
}

void OnDeinit(const int reason){
   int handle;
   string swrite;

   if( IsTesting() == true ){
      swrite = ""+IntegerToString(iIfchk[0])+","+IntegerToString(iIfchk[1])+","+IntegerToString(iIfchk[2])+","+IntegerToString(iIfchk[3])+",";
      handle = FileOpen("EAEditorDebug.csv",FILE_CSV|FILE_WRITE,',');
      if( handle > 0 ){
         FileWrite( handle, swrite );
         FileClose( handle );
      }
   }
   return;
}

